/************************************************************************
*  BiasF.h (Basic Interval Arithmetic Subroutines Standard Functions)
*
*  Version:                     1.4
*  Date:                        9/29/93
*  Author:                      O. Knueppel
*  Interval Representation:     any
*  Interval Implementation:     any
*************************************************************************/

#ifndef __BIASF__
#define __BIASF__

#include "Bias0.h"

/************************************************************************
*  Definition of Constants, Types, and Variables
*************************************************************************/

extern REAL     BiasPi;                 /* 3.141...                     */
extern REAL     BiasTwoPi;
extern REAL     BiasPiHalf;
extern REAL     BiasPiQuarter;
extern REAL     BiasE;
extern REAL     BiasSqrt2;
extern REAL     BiasInvSqrt2;           /* 1/ Sqrt(2)                   */
extern REAL     BiasLn10;

/************************************************************************
*  Function Prototypes
*************************************************************************/

#if defined (__cplusplus)
extern "C" {
#endif

VOID    BiasFuncInit    (VOID);

VOID    BiasSin    (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasCos    (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasTan    (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasCot    (const PBIASINTERVAL, const PBIASINTERVAL);

VOID    BiasArcSin (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasArcCos (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasArcTan (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasArcCot (const PBIASINTERVAL, const PBIASINTERVAL);

VOID    BiasSinh   (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasCosh   (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasTanh   (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasCoth   (const PBIASINTERVAL, const PBIASINTERVAL);

VOID    BiasArSinh (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasArCosh (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasArTanh (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasArCoth (const PBIASINTERVAL, const PBIASINTERVAL);

VOID    BiasExp    (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasLog    (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasLog10  (const PBIASINTERVAL, const PBIASINTERVAL);

VOID    BiasIAbs   (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasSqr    (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasSqrt   (const PBIASINTERVAL, const PBIASINTERVAL);
VOID    BiasRoot   (const PBIASINTERVAL, const PBIASINTERVAL, const INT);

VOID    BiasPowerN (const PBIASINTERVAL, const PBIASINTERVAL, const INT);
VOID    BiasPowerI (const PBIASINTERVAL, const PBIASINTERVAL, const PBIASINTERVAL);

#if defined (__cplusplus)
}
#endif

#endif /* __BIASF__ */
